import { Knex } from 'knex';
import { IGridRequestDto } from './GridRequestDto';
import GridResponse from './GridResponse';
export declare type FilterList = Record<string, Record<string, any>>;
export default abstract class AKnexGrid<T> {
    private knex;
    constructor(knex: Knex);
    protected filterableColumns: Record<string, string> | null;
    protected sortableColumns: Record<string, string> | null;
    protected searchableColumns: string[] | null;
    protected abstract searchQuery(knex: Knex): any;
    protected abstract toObject(data: Record<string, unknown>): T;
    filter(dto: IGridRequestDto): Promise<GridResponse<T>>;
    private addPaging;
    private addSorters;
    private addFilters;
    private getFilterableColumn;
    private static addOrExpression;
}
export declare type __ΩFilterList = any[];
